; Timing tests for pref-grid forms.  Package:  *LISP

(*cold-boot)

(*proclaim '(type signed-pvar x y u))

(*proclaim '(type boolean-pvar bdry))

(*defvar x (self-address-grid!! (!! 1)))  (*defvar y (!! 0))  (*defvar u (!! 0))
(*defvar gx (self-address-grid!! (!! 0)))

(*defvar bdry nil!!)

(defun rsx () (*set x (self-address-grid!! (!! 1))))

(defun grtma (n r)
"grtma n r  -- runs n tests of 'circular shift' to position r, 
               uses grid-rel border pvar to wrap."
 (dotimes (k n)
   (*set x (pref-grid-relative!! x (!! 0) (!! -1)
		 :border-pvar (pref-grid-relative!! x (!! 0) (!! r))))
   )
)

(defun grtmb (n r)
"grtmb n r  -- runs n tests of 'circular shift' to position r, 
               uses grid-abs border pvar to wrap."
 (dotimes (k n)
   (*set x (pref-grid-relative!! x (!! 0) (!! -1)
		 :border-pvar (pref-grid!! x gx (!! r))))
   )
)

(defun grtmc (n r)
"grtmc n r  -- runs n tests of 'circular shift' to position r, 
               uses *if and pref-grid to wrap."
 (*set bdry (=!! (self-address-grid!! (!! 1)) (!! 0)))
 (dotimes (k n)
   (*set x (if!! bdry (pref-grid!! x gx (!! r))
	              (pref-grid-relative!! x (!! 0) (!! -1)))))
)

(defun grtmd (n r)
"grtmd n r  -- runs n tests of 'circular shift' to position r, 
               uses *if and pref (cube) to wrap."
 (*set bdry (=!! (self-address-grid!! (!! 1)) (!! 0)))
 (*when bdry (*set y (cube-from-grid-address!! gx (!! r))))
 (dotimes (k n)
   (*if bdry (*set x (pref!! x y :no-collisions))
	     (*set x (pref-grid-relative!! x (!! 0) (!! -1))))
   )
)

(defun grtm0 (n)
"grtm0 n  -- runs n tests of 'right shift', filling with 0's."
 (dotimes (k n)
   (*set x (pref-grid-relative!! x (!! 0) (!! -1) :border-pvar (!! 0)))
   )
)

